#include "cache.h"

volatile unsigned long *dvd=(volatile long *)0xCC006000;

unsigned int dvd_read(void *dst, int len, unsigned int offset)
{
	if ((((int)dst) & 0xC0000000) == 0x80000000) // cached?
		dcache_inv(dst, len);

	dvd[0] = 0x2E;
	dvd[1] = 0;
	
	dvd[2] = 0xA8000000;
	dvd[3] = offset >> 2;
	dvd[4] = len;
	dvd[5] = (unsigned long)dst;
	dvd[6] = len;
	dvd[7] = 3; // enable reading!
	
	while (dvd[7] & 1);

	if (dvd[0] & 0x4)
		return 1;
	return 0;
}
